#ifndef __SOFT_IIC_H
#define __SOFT_IIC_H

/***********************************************
* Edit the port number to suit your hardware. *
***********************************************/
#define IIC_PORT P7
#define SCL_PIN P7_1
#define SCL_PIND PD7_1
#define SDA_PIN P7_0
#define SDA_PIND PD7_0

//Die Pausendauer wird mit Hilfe von CRYSTAL_FREQ (MAIN.H)
//und der Busgeschwindigkeit in kHz berechnet (max. 100000):
#define IIC_BUS_SPEED		100000

#define SCL SCL_PIN
#define SDA SDA_PIN
#define LOW 0
#define MSb 0x80
#define RX_SCL_STUCK_LOW 1
#define TX_SCL_STUCK_LOW 2
#define START_STUCK_LOW 3
#define STOP_SCL_STUCK_LOW 4

//Makros gendert fr PRC2-Bit-Protection:
#define SCL_HIZ {PRCR|=0x04; SCL_PIND = 0;}
#define SCL_LOW {SCL_PIN = 0; PRCR|=0x04; SCL_PIND = 1;}
#define SDA_HIZ {PRCR|=0x04; SDA_PIND = 0;}
#define SDA_LOW {SDA_PIN = 0; PRCR|=0x04; SDA_PIND = 1;}

/***********************************************************************************
* If you are using a fast core such as M16C or 7700 and need to slow down the IIC  *
* bus then uncomment the PAUSE line with the Nops. Although this bloats the code   *
* slightly it has a better resolution than "for" or "while" loops. 27 Nops gave    *
* an IIC bus speed of 100 kHz on an M16C/20 running at 10MHz (CPU clock = Xin).    *
***********************************************************************************/
//#define PAUSE { asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
// asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
// asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
// asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); \
// asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop");  asm("\tnop"); }
// 44 NOPS

#define IIC_DELAY (((CRYSTAL_FREQ / IIC_BUS_SPEED) / 80) + ((CRYSTAL_FREQ / IIC_BUS_SPEED) / 160) - 1)
#define PAUSE {temp_cnt=IIC_DELAY;while(temp_cnt)temp_cnt--;}

#define ACK 0
#define NO_ACK 1

unsigned char iic_byte_rx(unsigned char);
unsigned char iic_byte_tx(unsigned char);
void iic_error(unsigned char);
void iic_start(void);
void iic_stop(void);

unsigned char i2c_eeprom_byte_write(unsigned char device,unsigned char address, unsigned char value);
unsigned char i2c_eeprom_random_read(unsigned char device, unsigned char address);

#endif //__SOFT_IIC_H